
function init()
    SetString("game.tool.pipebomb.name","Lasers")
    
	deflectors = FindBodies("mirror2", true)
    
    laserLoop = LoadLoop("MOD/data/snd/laser-loop.ogg")
	laserHitLoop = LoadLoop("MOD/data/snd/laser-hit-loop.ogg")
	laserHitSound = LoadSound("light/spark0.ogg")
	laserSprite = LoadSprite("gfx/laser.png")
    lasers = {}
    ui = false
    MAX_DIST = 200
    MAX_LASERS = 50
    ENABLED = true
    OPTION_GLOBAL_KEYS = false
    OPTION_EXPODE = false
    OPTION_EXPLODE_TIME = 2
    OPTION_EXPLODE_SIZE = 1
    OPTION_STICKY = true
    OPTION_POWER = 1
    OPTION_SMOKE = true

    -- init settings
    if GetString("savegame.mod.maxlasers")          == "" then SetString("savegame.mod.maxlasers","50") end
    if GetString("savegame.mod.distance")           == "" then SetString("savegame.mod.distance","200") end
    if GetString("savegame.mod.power")              == "" then SetString("savegame.mod.power","Normal") end
    if GetString("savegame.mod.smoke")              == "" then SetString("savegame.mod.smoke","Yes") end
    if GetString("savegame.mod.explode")            == "" then SetString("savegame.mod.explode","No") end
    if GetString("savegame.mod.explodetime")        == "" then SetString("savegame.mod.explodetime","2 sec") end
    if GetString("savegame.mod.explodesize")        == "" then SetString("savegame.mod.explodesize","Small") end
    if GetString("savegame.mod.keytoggle")          == "" then SetString("savegame.mod.keytoggle","T") end
    if GetString("savegame.mod.keytogglesingle")    == "" then SetString("savegame.mod.keytogglesingle","C") end
    if GetString("savegame.mod.keyclear")           == "" then SetString("savegame.mod.keyclear","K") end
    if GetString("savegame.mod.keysglobal")         == "" then SetString("savegame.mod.keysglobal","Yes") end
    if GetString("savegame.mod.color")              == "" then SetString("savegame.mod.color","Red") end
    
end

function tick(dt)
    -- DebugWatch("lasers",#lasers)
    local propMaxLasers = GetString("savegame.mod.maxlasers")
    if propMaxLasers == "Infinite" then
        MAX_LASERS = 9999
    else
        MAX_LASERS = tonumber(propMaxLasers)
    end
    
    local propPower = GetString("savegame.mod.power")
    if propPower == "Useless" then
        OPTION_POWER = 0
    elseif propPower == "Normal" then
        OPTION_POWER = 1
    elseif propPower == "Strong" then
        OPTION_POWER = 4
    elseif propPower == "Insane" then
        OPTION_POWER = 8
    end
    
    local propDistance = GetString("savegame.mod.distance")
    MAX_DIST = tonumber(propDistance)

    local propSmoke = GetString("savegame.mod.smoke")
    if propSmoke == "Yes" then
        OPTION_SMOKE = true
    elseif propSmoke == "No" then
        OPTION_SMOKE = false
    end

    local propExplode = GetString("savegame.mod.explode")
    if propExplode == "Yes" then
        OPTION_EXPODE = true
    elseif propExplode == "No" then
        OPTION_EXPODE = false
    end
    
    local propExplodeTime = GetString("savegame.mod.explodetime")
    if propExplodeTime == "2 sec" then
        OPTION_EXPLODE_TIME = 2
    elseif propExplodeTime == "5 sec" then
        OPTION_EXPLODE_TIME = 5
    elseif propExplodeTime == "10 sec" then
        OPTION_EXPLODE_TIME = 10
    end

    local propExplodeSize = GetString("savegame.mod.explodesize")
    if propExplodeSize == "Small" then
        OPTION_EXPLODE_SIZE = 0.1
    elseif propExplodeSize == "Medium" then
        OPTION_EXPLODE_SIZE = 1
    elseif propExplodeSize == "Large" then
        OPTION_EXPLODE_SIZE = 2
    end

    local propKeyToggle = GetString("savegame.mod.keytoggle")
    local propKeyToggleSingle = GetString("savegame.mod.keytogglesingle")
    local propKeyClear = GetString("savegame.mod.keyclear")
    local propKeysGlobal = GetString("savegame.mod.keysglobal")
    local propColor = GetString("savegame.mod.color")
    
    local checkInput = false
    
    local stickTransform = nil
    
    if GetString("game.player.tool") == "pipebomb" then
        checkInput = true

        if GetBool("game.player.canusetool") and InputDown('rmb') then
            local t = GetCameraTransform()
            local dir = TransformToParentVec(t, Vec(0, 0, - 1))

            -- DrawLine(t.pos, VecAdd(t.pos, VecScale(dir, 5)), 1,1,0,0.5)

            local hit, dist, normal, shape = QueryRaycast(t.pos, dir, 100)
            if hit then
                -- DebugPrint('hit')
                local hitpoint = VecAdd(t.pos, VecScale(dir, dist))
                DrawLine(hitpoint, VecAdd(hitpoint, VecScale(normal, 0.2)), 1, 1, 0, 1)
                DrawLine(hitpoint, VecAdd(hitpoint, VecScale(normal, 0.5)), 1, 0, 0, 1)
                DrawLine(VecAdd(hitpoint, VecScale(normal, 0.5)), VecAdd(hitpoint, VecScale(normal, 1)), 1, 0, 0, 0.5)
                -- DrawShapeOutline(shape, 1, 0, 0, 1)
                -- if GetDescription(shape) == "ground" then
                --     print(shape)
                -- end

                if InputDown('lmb') then
                    -- local lookPoint = TransformToParentPoint(Transform(hitpoint,Quat()), VecScale(normal,5))
                    hitpoint = VecAdd(hitpoint,VecScale(normal,0.35))
                    local lookPoint = VecSub(hitpoint,normal)
                    local rot = QuatLookAt(hitpoint,lookPoint)
                    rot = QuatRotateQuat(rot,QuatEuler(90,0,0))
                    stickTransform = Transform(hitpoint,rot)
                end

            end
            
        end
    end
        
    if checkInput or propKeysGlobal == "Yes" then
        if InputPressed(string.lower(propKeyClear)) then
            for i=#lasers,1,-1 do
                local laser = lasers[i]
                laser.remove = true
            end
        end

        if InputPressed(string.lower(propKeyToggle)) then
            ENABLED = not ENABLED
            for i=1,#lasers do
                local laser = lasers[i]
                laser.enabled = ENABLED
            end
        end
        
        if InputPressed(string.lower(propKeyToggleSingle)) then
            local t = GetCameraTransform()
            local dir = TransformToParentVec(t, Vec(0, 0, - 1))
            local hit, dist, normal, shape = QueryRaycast(t.pos, dir, 100)
            if hit then
                for i=1,#lasers do
                    local laser = lasers[i]
                    if laser.shape == shape then
                        laser.enabled = not laser.enabled
                    end
                end
            end
        end
    end

    
    prelasers = FindShapes("bomb",true)
    for i=1, #prelasers do
        local laser = prelasers[i]
        if GetShapeVoxelCount(laser) == 28 then
            local laserBody = GetShapeBody(laser)
            RemoveTag(laser,"bomb")
            RemoveTag(laser,"smoke") 
            SetTag(laser,"unbreakable")
            SetTag(laserBody,"mirror")
            if #lasers > MAX_LASERS-1 then
                Delete(lasers[1].shape)
                table.remove(lasers,1)
            end
            local colorRed = {r=1.0,g=0.1,b=0.1}
            local colorGreen = {r=0.1,g=1.0,b=0.1}
            local colorBlue = {r=0.1,g=0.1,b=1.0}
            local colorYellow = {r=1.0,g=1.0,b=0.1}
            local colorCyan = {r=0.1,g=1.0,b=1.0}
            local colorMagenta = {r=1.0,g=0.1,b=1.0}
            local colorWhite = {r=1.0,g=1.0,b=1.0}
            local colors = {colorRed,colorBlue,colorGreen,colorYellow,colorCyan,colorMagenta}
            
            local color = colorRed -- default
            if propColor == "Green" then
                color = colorGreen
            elseif propColor == "Blue" then
                color = colorBlue
            elseif propColor == "Yellow" then
                color = colorYellow
            elseif propColor == "Cyan" then
                color = colorCyan
            elseif propColor == "Magenta" then
                color = colorMagenta
            elseif propColor == "White" then
                color = colorWhite
            elseif propColor == "Random" then
                color = colors[math.random(1,#colors)]
            end
            
            local sticky = false
            if stickTransform then
                -- SetBodyDynamic(laserBody, false)
                SetBodyTransform(laserBody, stickTransform)
                sticky = true
            end
            
            table.insert(lasers,{shape=laser,dist=0,hitscale=0,bombtimer=0,color=color,remove=false,sticky=sticky,enabled=ENABLED})
        end
    end

    -- DebugWatch("lasers",#lasers)
    for i=1, #lasers do
        laserCalc(lasers[i], dt)
    end
    for i=#lasers, 1, -1 do
        local laser = lasers[i]
        if laser.remove then
            Delete(laser.shape)
            table.remove(lasers,i)
        end
    end
	
end

function laserCalc(laser, dt)
    if OPTION_EXPODE then
        laser.bombtimer = laser.bombtimer + dt
        -- DebugPrint(laser.bombtimer)
        if laser.bombtimer > OPTION_EXPLODE_TIME  then
            Explosion(GetShapeWorldTransform(laser.shape).pos,OPTION_EXPLODE_SIZE)
            laser.remove = true
        end
    end

    if laser.enabled then
        
            local emitTransformOffset = Transform(Vec(0.1,0.6,0.1),QuatEuler(90,0,0))
            local emitTransform = TransformToParentTransform(GetShapeWorldTransform(laser.shape),emitTransformOffset)
            local origin = emitTransform.pos
            
            
            PlayLoop(laserLoop, origin, 0.5)
            local dir = TransformToParentVec(emitTransform, Vec(0, 0, -1))
            local length, hitPoint, hitBody, hitShape, hit = shootLaser(GetShapeBody(laser.shape), laser.shape, origin, dir, 0, laser.color, {})
            if length ~= laser.dist then
                laser.hitscale = 1
                laser.dist = length
            end
            laser.hitscale = math.max(0.0, laser.hitscale - dt)
            if laser.hitscale > 0 then
                PlayLoop(laserHitLoop, endPoint, laser.hitscale)
                PointLight(hitPoint, laser.color.r, laser.color.g, laser.color.b, rnd(2.0, 4.0)*laser.hitscale)
            end
            PointLight(hitPoint, laser.color.r, laser.color.g, laser.color.b, rnd(0.5, 1.0))
            
            if hit then
                if OPTION_SMOKE then
                    emitSmoke(hitPoint, 1.0)
                end
                if OPTION_POWER > 0 and OPTION_POWER <= 1 then
                    MakeHole(hitPoint, 0.5 * OPTION_POWER, 0.3 * OPTION_POWER, 0, true)
                end
                if OPTION_POWER > 1 then
                    MakeHole(hitPoint, 0.5 * OPTION_POWER, 0.3 * OPTION_POWER, OPTION_POWER, true)
                end
            end
        
    end

    if laser.sticky then
        -- stickyTransformOffset1 = Transform(Vec(0.1,-0.05,0.1),QuatEuler(90,0,0))
        -- stickyTransformOffset1 = Transform(Vec(0.1,-0.05,0.1),QuatEuler(90,0,0))
        -- stickyTransform1 = TransformToParentTransform(GetShapeWorldTransform(laser.shape),emitTransformOffset1)
        -- stickyTransformOffset2 = Transform(Vec(0.1,-0.1,0.1),QuatEuler(90,0,0))
        -- stickyTransform2 = TransformToParentTransform(GetShapeWorldTransform(laser.shape),emitTransformOffset2)

        local stickyTransformOffset = Transform(Vec(0.1,0.0,0.1),QuatEuler(90,0,0))
        local stickyTransform = TransformToParentTransform(GetShapeWorldTransform(laser.shape),stickyTransformOffset)
        local sdir = TransformToParentVec(stickyTransform, Vec(0, 0, 1))
        QueryRejectShape(laser.shape)
        QueryRejectBody(GetShapeBody(laser.shape))
        local shit, shitDist, shitNormal, shitShape = QueryRaycast(stickyTransform.pos, sdir, 0.1, 0.0, true)
        if shit then
            
            local shitPoint = VecAdd(stickyTransform.pos, VecScale(sdir, shitDist))
            local laserBody = GetShapeBody(laser.shape)
            
            local otherBody = GetShapeBody(shitShape)
            local lookPoint = VecSub(shitPoint,VecScale(shitNormal,0.1))
            
            local hp = VecAdd(shitPoint,VecScale(shitNormal,0.35))
            local lp = VecSub(hp,shitNormal)
            local rot2 = QuatLookAt(hp,lp)
            rot2 = QuatRotateQuat(rot2,QuatEuler(90,0,0))
            local t = Transform(hp,rot2)

            laser.sticky = {laserBody,otherBody,stickyTransform,shitPoint,t}
            
        else
            laser.sticky = false
        end
        
    end
    
end


function update()
    for i=1,#lasers do
        local laser = lasers[i]
        -- sticky 
        if laser.sticky then
            local laserBody = laser.sticky[1]
            local otherBody = laser.sticky[2]
            local stickyTransform = laser.sticky[3]
            local shitPoint = laser.sticky[4]
            local bodyTransform = laser.sticky[5]
            ConstrainPosition(laserBody, otherBody, stickyTransform.pos, shitPoint)
            ConstrainOrientation(laserBody, otherBody, bodyTransform.rot, bodyTransform.rot)
        end
        
    end
end




function rnd(mi, ma)
	return math.random(1000)/1000*(ma-mi) + mi
end

function rndVec(t)
	return Vec(rnd(-t, t), rnd(-t, t), rnd(-t, t))
end 



function emitSmoke(pos, amount)
	ParticleReset()
	ParticleType("smoke")
	ParticleColor(0.8, 0.8, 0.8)
	ParticleRadius(0.2, 0.4)
	ParticleAlpha(0.5, 0)
	ParticleDrag(0.5)
	ParticleGravity(rnd(0.0, 2.0))
	SpawnParticle(VecAdd(pos, rndVec(0.01)), rndVec(0.1), rnd(1.0, 3.0))

	ParticleReset()
	ParticleEmissive(5, 0, "easeout")
	ParticleGravity(-10)
	ParticleRadius(0.01, 0.0, "easein")
	ParticleColor(1, 0.4, 0.3)
	ParticleTile(4)
	local vel = VecAdd(Vec(0, 1, 0), rndVec(2.0))
	SpawnParticle(pos, vel, rnd(1.0, 2.0))
end


function getDistanceToLineSegment(point, p0, p1)
    local line_vec = VecSub(p1, p0)
    local pnt_vec = VecSub(point, p0)
    local line_len = VecLength(line_vec)
    local line_unitvec = VecNormalize(line_vec)
    local pnt_vec_scaled = VecScale(pnt_vec, 1.0/line_len)
    local t = VecDot(line_unitvec, pnt_vec_scaled)    
    if t < 0.0 then
        t = 0.0
    elseif t > 1.0 then
        t = 1.0
	end
    local nearest = VecScale(line_vec, t)
    local dist = VecLength(VecSub(nearest, pnt_vec))
    local nearest = VecAdd(nearest, p0)
    return dist, nearest
end


function shootLaser(body, shape, origin, dir, currentLength, color, deflectorsHit)
	--Raycast
	QueryRequire("physical")
	if shape ~= 0 then
		QueryRejectShape(shape)
	end
	if body ~= 0 then
		QueryRejectBody(body)
	end
	local hit, hitDist, hitNormal, hitShape = QueryRaycast(origin, dir, MAX_DIST, 0.0, true)
	local length = MAX_DIST
	if hit then
		length = hitDist
	end
	local hitPoint = VecAdd(origin, VecScale(dir, length))
	
	local t = Transform(VecLerp(origin, hitPoint, 0.5))
	local xAxis = VecNormalize(VecSub(hitPoint, origin))
	local zAxis = VecNormalize(VecSub(origin, GetCameraTransform().pos))
	t.rot = QuatAlignXZ(xAxis, zAxis)
	DrawSprite(laserSprite, t, length, 0.05+math.random()*0.01, 8, 4, 4, 1, true, true)
	DrawSprite(laserSprite, t, length, 0.5, color.r, color.g, color.b, 1, true, true)
    -- 
	-- --Check if player if hit by laser
	-- local ppos = GetPlayerCameraTransform().pos
	-- ppos[2] = ppos[2] - PLAYER_HIT_RADIUS*0.5
	-- local pdist, phit = getDistanceToLineSegment(ppos, origin, hitPoint)
	-- if pdist < PLAYER_HIT_RADIUS then
	-- 	--Decrease health but don't kill
	-- 	local health = GetPlayerHealth()
	-- 	health = math.max(0.1, health - 0.3)
	-- 	SetPlayerHealth(health)
	-- 	ReleasePlayerGrab()
    -- 
	-- 	--Disance to player, without vertical component
	-- 	local pdir = VecSub(ppos, phit)
	-- 	pdir[2] = 0
	-- 	pdir = VecNormalize(pdir)
    -- 
	-- 	--Move player and give a nudge
	-- 	local pt = GetPlayerTransform(true)
	-- 	pt.pos = VecAdd(pt.pos, VecScale(pdir, PLAYER_HIT_RADIUS-pdist+0.1))
	-- 	SetPlayerTransform(pt, true)
	-- 	SetPlayerVelocity(VecScale(pdir, 10))
    -- 
	-- 	--Play hit sound
	-- 	PlaySound(laserHitSound, ppos)
	-- end

    --Check if directed
	local hitBody = GetShapeBody(hitShape)
	if HasTag(hitBody, "mirror2") and currentLength < MAX_DIST then
		--Only allow the beam to hit a deflector once
		local alreadyHit = false
		for i=1, #deflectorsHit do
			if deflectorsHit[i] == hitBody then
				alreadyHit = true
				break
			end
		end
		if not alreadyHit then
			deflectorsHit[#deflectorsHit+1] = hitBody
			local t = GetBodyTransform(hitBody)
			local refDir = TransformToParentVec(t, Vec(0, 0, 1))
			SetShapeEmissiveScale(hitShape, 1)
			return shootLaser(hitBody, hitShape, t.pos, refDir, currentLength + length, color, deflectorsHit)
		end
	end

	--Check if reflected
	local hitBody = GetShapeBody(hitShape)
    -- SetTag(hitBody,"mirror")
	if HasTag(hitBody, "mirror") and currentLength < MAX_DIST and hitDist > 0.001 then
		local refDir = VecSub(dir, VecScale(hitNormal, VecDot(hitNormal, dir)*2))
		return shootLaser(hitBody, hitShape, hitPoint, refDir, currentLength + length, color)
	end
	return currentLength + length, hitPoint, hitBody, hitShape, hit
end



--Helper function for UI to configure properties
function property(name, list, key)
	local current = GetString(key)
	if current == "" then 
		current = list[1]
	end
	UiPush()
        UiColor(1, 1, 1, 0.7)
		UiFont("bold.ttf", 26)
		UiText(name)
		UiTranslate(200, 0)
        UiColor(1, 1, 1, 1)
		UiFont("bold.ttf", 26)
		if UiTextButton(current,100) then
			local new = nil
			for i=1, #list-1 do
				if list[i] == current then
					new = list[i+1]		
				end
			end
			if new then
				SetString(key, new)
			else
				SetString(key, list[1])
			end
		end
	UiPop()
end

--Configuration UI
function draw()
	if GetString("game.player.tool") == "pipebomb" then
        
        local propMenuHint = GetString("savegame.mod.menuhint")
        
		UiFont("regular.ttf", 22)
		UiTextShadow(0, 0, 0, 0.5, 0.5)
		if not uix then uix = UiWidth() - 220 end
		if not uiy then uiy = 30 end

		UiTranslate(uix, uiy)

		if InputPressed(string.lower("m")) then
			ui = not ui
			if ui then
                if propMenuHint == "Yes" then
                    SetValue("uix", UiCenter()-100, "cosine", 0.15)
    				SetValue("uiy", UiMiddle()-100, "cosine", 0.15)
                else
                    uix = UiCenter()-100
    				uiy = UiMiddle()-100
                    UiTranslate(uix, uiy)
                end
			else
                if propMenuHint == "Yes" then
                    SetValue("uix", UiWidth()-220, "cosine", 0.15)
    				SetValue("uiy", 30, "cosine", 0.15)
                else
                    uix = UiWidth()-220
    				uiy = 30
                end
			end
		end

        


		if ui then
            UiPush()
                UiTranslate(-20, -40)
                UiColor(0, 0, 0, 0.9)
                UiImageBox("ui/common/box-solid-6.png", 320, 435, 6, 6)
            UiPop()
            UiColor(1,1,1,1)

			UiMakeInteractive()
			UiText("Press M to hide")
			UiTranslate(0, 30)
			property("Maximum Lasers", {"25", "50", "100", "200", "Infinite"}, "savegame.mod.maxlasers")
            UiTranslate(0, 26)
            property("Laser Distance", {"1", "2", "5", "10", "25", "50", "100", "200"}, "savegame.mod.distance")
			UiTranslate(0, 26)
            property("Laser Power", {"Useless", "Normal", "Strong", "Insane"}, "savegame.mod.power")
			UiTranslate(0, 26)
            property("Laser Smoke", {"Yes", "No"}, "savegame.mod.smoke")
			UiTranslate(0, 26)
            property("Laser Color", {"Red", "Green", "Blue", "Yellow", "Cyan", "Magenta", "White", "Random"}, "savegame.mod.color")
			UiTranslate(0, 26)
            property("Explode", {"No", "Yes"}, "savegame.mod.explode")
			UiTranslate(0, 26)
            property("Explode Time", {"2 sec", "5 sec", "10 sec"}, "savegame.mod.explodetime")
			UiTranslate(0, 26)
            property("Explode Size", {"Small", "Medium", "Large"}, "savegame.mod.explodesize")
			UiTranslate(0, 26)
            property("Key Toggle", {"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","Q","R","S","T","U","V","W","X","Y","Z"}, "savegame.mod.keytoggle")
			UiTranslate(0, 26)
            property("Key Toggle Single", {"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","Q","R","S","T","U","V","W","X","Y","Z"}, "savegame.mod.keytogglesingle")
			UiTranslate(0, 26)
            property("Key Clear",  {"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","Q","R","S","T","U","V","W","X","Y","Z"}, "savegame.mod.keyclear")
			UiTranslate(0, 26)
            property("Keys Global",  {"Yes", "No"}, "savegame.mod.keysglobal")
			UiTranslate(0, 26)
            property("Show Menu Hint",  {"Yes", "No"}, "savegame.mod.menuhint")
			UiTranslate(0, 32)
            
            -- reset 
            UiColor(1, 0.2, 0.2, 1)
    		UiFont("bold.ttf", 22)
    		if UiTextButton("RESET ALL",100) then
                resetOptions()
            end
            

		else
            
            if propMenuHint == "Yes" then
                UiText("Press M for Laser Menu")
            end
		end
	end
end

function resetOptions()
    -- init settings
    SetString("savegame.mod.maxlasers","50")
    SetString("savegame.mod.distance","200")
    SetString("savegame.mod.power","Normal")
    SetString("savegame.mod.smoke","Yes")
    SetString("savegame.mod.explode","No")
    SetString("savegame.mod.explodetime","2 sec")
    SetString("savegame.mod.explodesize","Small")
    SetString("savegame.mod.keytoggle","T")
    SetString("savegame.mod.keyclear","K")
    SetString("savegame.mod.keytogglesingle","C")
    SetString("savegame.mod.keysglobal","Yes")
    SetString("savegame.mod.color","Red")
    SetString("savegame.mod.menuhint","Yes")
end


